#!/usr/bin/env node
"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}require("loud-rejection/register");var RenderKid=_interopDefault(require("renderkid")),fs=_interopDefault(require("fs")),unglob=_interopDefault(require("glob")),match=_interopDefault(require("minimatch")),promisify=_interopDefault(require("es6-promisify")),path=require("path"),findUp=_interopDefault(require("find-up")),rollup=require("rollup"),TS=_interopDefault(require("trie-search")),transmutation=require("transmutation"),uglifyEs=require("uglify-es"),babel=_interopDefault(require("rollup-plugin-babel")),uglify=_interopDefault(require("rollup-plugin-uglify")),filesize=_interopDefault(require("rollup-plugin-filesize")),nodeResolve=_interopDefault(require("rollup-plugin-node-resolve")),executable=_interopDefault(require("rollup-plugin-executable")),style={list:{display:"block",marginTop:1},item:{display:"block",marginBottom:1},attr:{display:"block",marginLeft:2},key:{color:"grey",marginRight:1},value:{color:"white"},bar:{display:"block",color:"green"},h1:{display:"block",color:"bright-white",marginLeft:2}};const renderer=new RenderKid;renderer.style(style);var formatter=({template:e=""}={})=>renderer.render(e),asyncToGenerator=function(e){return function(){var r=e.apply(this,arguments);return new Promise(function(e,t){function n(i,a){try{var o=r[i](a),l=o.value}catch(e){return void t(e)}if(!o.done)return Promise.resolve(l).then(function(e){n("next",e)},function(e){n("throw",e)});e(l)}return n("next")})}},_extends=Object.assign||function(e){for(var r=1;r<arguments.length;r++){var t=arguments[r];for(var n in t)Object.prototype.hasOwnProperty.call(t,n)&&(e[n]=t[n])}return e};const glob=promisify(unglob),lstat=promisify(fs.lstat),have=e=>r=>match(e,r);var findPackages=({root:e=".",exclude:r=[]}={})=>new Promise((()=>{var t=asyncToGenerator(function*(t,n){try{const i=path.resolve(e,"src/node_modules");if(!(yield lstat(i)).isDirectory)return n("NO");const a=path.resolve(i,"**/package.json");return t((yield glob(a)).filter(function(e){return!r.some(have(e))}).map(function(e){const r=require(e);return{dir:path.dirname(e),name:r.name,bin:r.bin,main:r.main,config:r}}).filter(function(e){return e.name}))}catch(e){return n(e)}});return function(e,r){return t.apply(this,arguments)}})()),findRepoRoot=({anchor:e=".git"}={})=>findUp(e).then(path.dirname);const lstat$1=promisify(fs.lstat);var checkPackages=({packages:e=[]}={})=>new Promise((()=>{var r=asyncToGenerator(function*(r){if(0===e.length)return r([]);return r(yield Promise.all(e.map((()=>{var e=asyncToGenerator(function*(e){if(!e.name)return _extends({},e,{publishable:!1});try{const r=path.resolve(e.dir,"readme.md");if(!(yield lstat$1(r)).isFile)return _extends({},e,{publishable:!1})}catch(r){return _extends({},e,{publishable:!1})}try{if(e.main||!e.bin){const r=path.resolve(e.dir,e.main||"index.js");if(!(yield lstat$1(r)).isFile)return _extends({},e,{publishable:!1})}else if(e.bin){const r=Object.values(e.bin);if((yield Promise.all(r.map(function(r){return path.resolve(e.dir,r)}).map((()=>{var e=asyncToGenerator(function*(e){return lstat$1(e)});return function(r){return e.apply(this,arguments)}})()))).some(function(e){return!e.isFile}))return _extends({},e,{publishable:!1})}}catch(r){return _extends({},e,{publishable:!1})}return _extends({},e,{publishable:!0})});return function(r){return e.apply(this,arguments)}})())))});return function(e){return r.apply(this,arguments)}})()),buildPackages=({configs:e=[]}={})=>Promise.all(e.map(e=>rollup.rollup({input:e.input,external:e.external,plugins:e.plugins}).then(r=>Promise.all(e.output.map(t=>r.write({file:t.file,format:t.format,banner:e.banner})))))),createSearcher=({commands:e=[]}={})=>{const r=e.map(e=>{const r=Array.isArray(e.aliases)?e.aliases:[e.aliases];return _extends({},e,{tokens:[e.name,...r].join(" ")})}),t=new TS(["tokens"]);return t.addAll(r),t};const isPromise=e=>!!e&&("object"==typeof e||"function"==typeof e)&&"function"==typeof e.then;var createExecutor=({searcher:e,defaultStyle:r,defaultRenderer:t=console.log})=>n=>{const i=e.get(n[0])[0],a=i.run(),o=i.renderer||t,l=new RenderKid;if(l.style(r),isPromise(a))return a.then(e=>i.template?l.render(i.template(e)):e).then(o);return o(i.template?l.render(i.template(a)):a)};const jsonRenderer=e=>console.log(JSON.stringify(e,null,4)),configureKli=({defaultStyle:e,defaultRenderer:r=console.log}={})=>({commands:t=[]}={})=>{if(!Array.isArray(t))throw new Error("Commands must be an array");if(0===t.length)throw new Error("No commands defined");if(t.forEach(e=>{if("function"!=typeof e.run)throw new Error("All commands must have a run method")}),1===t.length)return{execute:()=>t[0].run()};const n=createSearcher({commands:t});return{execute:createExecutor({searcher:n,defaultStyle:e,defaultRenderer:r})}},configure=configureKli,kli$1=configureKli({defaultRenderer:console.log});configureKli({defaultRenderer:console.log});var findBaseConfig=({root:e="."}={})=>require(path.resolve(e,"package.json")),formatPackageList=e=>`\n    <bar>--------------------------------------------------------------------------------</bar>\n    <h1>Package List</h1>\n    <bar>--------------------------------------------------------------------------------</bar>\n    <list>\n        ${e.map(e=>`<item>\n                <attr><key>Name:</key><value>${e.name}</value></attr>\n                <attr><key>Version:</key><value>${e.version||"No version"}</value></attr>\n            </item>`).join("")}\n    </list>\n    `;const babelConfig={babelrc:!1,presets:[["env",{modules:!1,targets:{node:"6"}}],"stage-0"],plugins:["external-helpers"],exclude:["node_modules/**"]};var buildRollupConfigs=({root:e=".",packages:r=[],baseConfig:t={dependencies:{}}}={})=>new Promise(n=>n([].concat(...r.filter(e=>e.bin).filter(e=>e.bin.constructor===Object).map(r=>Object.values(r.bin).map(n=>({input:path.resolve(e,"src/node_modules",r.name,n),external:[...Object.keys(t.dependencies),"fs","path","util"],output:[{file:path.resolve(e,"dist",r.name,n),format:"cjs"}],banner:"#!/usr/bin/env node",plugins:[nodeResolve({customResolveOptions:{moduleDirectory:"src/node_modules"},preferBuiltins:!0}),babel(babelConfig),uglify({},uglifyEs.minify),executable(),filesize()]}))))));const kli=configure({defaultStyle:style}),cli=kli({commands:[{name:"list",aliases:["ls"],template:formatPackageList,formatter:formatter,run:()=>transmutation.transmute({}).extend("root",findRepoRoot).extend("exclude",["**/fixtures/**"]).extend("packages",findPackages).then(transmutation.isolate("packages"))},{name:"check",renderer:jsonRenderer,run:()=>transmutation.transmute({}).extend("root",findRepoRoot).extend("baseConfig",findBaseConfig).extend("exclude",["**/fixtures/**"]).extend("packages",findPackages).extend("checkedPackages",checkPackages).then(transmutation.isolate("checkedPackages"))},{name:"build",renderer:()=>{},run:()=>transmutation.transmute({}).extend("root",findRepoRoot).extend("baseConfig",findBaseConfig).extend("exclude",["**/fixtures/**"]).extend("unfiltered",findPackages).extend("packages",({unfiltered:e})=>e.filter(e=>e.bin)).extend("configs",buildRollupConfigs).then(buildPackages)}]});cli.execute(process.argv.slice(2));
